import QtQuick 1.1

import eway 1.0
import "config.js" as Config

Item {
	property ListModel model : ListModel { id: routeListModel }

	property int stopId
	onStopIdChanged: updateRoutes()

	Eway { 
		id: eway 
		onGotReply: setRoutes(JSON.parse(jsonString).routes)
	}

	function updateRoutes()
	{
		eway.getStopInfo("kyiv", stopId)
	}

	function compareTransport(r1, r2)
	{
		return Config.transportRank[r1.transportName]
				- Config.transportRank[r2.transportName]
	}

	function fixMetroTitle(r)
	{
		if(r.transportName === "Метро")
			r.title = "М" + r.title
	}

	function setRoutes(routes)
	{
		var i

		routes.sort(compareTransport)

		for(i=0; i < routeListModel.count && i < routes.length; i++) {
			fixMetroTitle(routes[i])
			routeListModel.set(i, routes[i])
		}
		for(; i < routeListModel.count; i++)
			routeListModel.remove(i);
		for(; i < routes.length; i++) {
			fixMetroTitle(routes[i])
			routeListModel.append(routes[i])
		}
	}
}
