import QtQuick 1.1
import QtMobility.location 1.2

import eway 1.0
import "config.js" as Conf

Item {

	property ListModel model : ListModel { id: stopListModel }

	property Coordinate location 

	// For some reason, OnLocationChange is not called when the contents of the
	// 'location' property  are changed. One needs to call the 'moved' signal
	// when the location is changed.
	signal moved
	onMoved: eway.getStopsNearPoint("kyiv",
									location.latitude, location.longitude, 
									Conf.stopsRadius)
	Eway { 
		id: eway 
		onGotReply: setStops(JSON.parse(jsonString).stop)
	}

	Coordinate { id: aStopCoord }
	function distanceTo(stop)
	{
		aStopCoord.latitude = stop.lat
		aStopCoord.longitude = stop.lng
		return location.distanceTo(aStopCoord)
	}

	function closestFirst(stop1, stop2)
	{
		return distanceTo(stop1) - distanceTo(stop2)
	}
	
	function setStops(stops)
	{
		stops.sort(closestFirst)
		stopListModel.clear()
		for(var key in stops)
			stopListModel.append(stops[key])
	}
}
